import sys
import math

curtest = 2

def solve(data):
    s = dict()
    for x in data:
        for j in range(len(x)):
            c1 = x[j]
            c2 = x[j - 1]
            if c1 > c2:
                c1, c2 = c2, c1
            if (c1, c2) not in s:
                s[(c1, c2)] = 1
            else:
                s[(c1, c2)] += 1

    a = []
    for p in s:
        a.append((s[p], p))
    a.sort()

    i = len(a) - 1
    while i >= 0 and a[i][0] == a[-1][0]:
        i -= 1

    return len(a) - i - 1 


was = set()

def test(s):
    global curtest
    global was
    f = open("%02d" % curtest, "w")
    print(len(s), file=f)
    for x in s:
       print(x, file=f)
    f.close()
    print(s)
    curtest += 1

def unique(s):
    if solve(s) != 1:
        print("not unique ", s)
        exit(1)
    test(s)

def random_rgb(l):
    r = ""
    for i in range(l):
        r += "RGB"[random.randint(0, 2)]
    return r

def random_unique(n, maxl):
    while True:
        s = []
        for i in range(n):
            l = random.randint(3, maxl)
            s.append(random_rgb(l))
        v = solve(s)
        if v == 1:
            break
    unique(s)

def random_non_unique(n, minl, maxl, ac):
    print("looking for", ac)
    while True:
        s = []
        for i in range(n):
            l = random.randint(minl, maxl)
            s.append(random_rgb(l))
        v = solve(s)
        if v == ac:
            break
    test(s)

def try_random_non_unique(n, minl, maxl, ac):
    print("looking for", ac)
    retries = 0
    while True:
        retries += 1
        if retries > 10:
            return False
        s = []
        for i in range(n):
            l = random.randint(minl, maxl)
            s.append(random_rgb(l))
        v = solve(s)
        if v == ac:
            break
    test(s)
    return True

import random
random.seed("ilash")

# group 1, n = 1, unique solution
test(["RRR"])
test(["GGG"])
test(["BBB"])
test(["R" * 1000])
test(["G" * 1000])
test(["B" * 1000])
unique(["RGGGBB" * (1000//6)])
for r in [10, 100, 1000]:
    random_unique(1, r)

# group 2, n = 1
test(["RGB"])
test(["RGRG"])
test(["RRGGBB"])
test(["RGB" * 333])
for r in [10, 30]:
    for ac in [2, 5, 6]:
        random_non_unique(1, r // 2, r, ac)
for r in [100]:
    for ac in [2, 3, 4]:
        random_non_unique(1, r // 3, r, ac)
for r in [1000]:
    for ac in [2, 3]:
        random_non_unique(1, r // 3, r, ac)

# group 3, unique solution
for r in [10, 23, 77, 100, 1000]:
    n = random.randint(2, 100)
    random_unique(n, r)

for i in range(5):
    n = random.randint(2, 100)
    r = random.randint(3, 1000)
    random_unique(n, r)

# group 4, no constraints
test(["RRGGBB" for i in range(100)])
test(["RRGGBB" * (1000//6) for i in range(100)])
for i in range(6):
    print("random test " + str(i) + " of 18")
    while True:
        n = random.randint(2, 10)
        r = random.randint(3, 1000)
        q = random.randint(2, 3)
        if try_random_non_unique(n, r // 5, r, q):
            break

for i in range(2):
    print("random test " + str(i) + " of 18")
    while True:
        n = random.randint(2, 100)
        r = random.randint(3, 1000)
        q = random.randint(2, 3)
        if try_random_non_unique(n, r // 5, r, q):
            break

