#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int MAXN = 100;

int solve(vector<string> s) {
    map<string, int> cnt;
    for (string x : s) {
        for (int j = 0; j < x.size(); j++) {
            char c1 = x[j];
            char c2 = x[(j + 1) % x.size()];
            if (c1 > c2) {
                char t = c1; c1 = c2; c2 = t;
            }
            cnt["" + c1 + c2] += 1;
        }
    }
    int ans = 0;
    int best = -1;
    for (auto x : cnt) {
        if (x.second > best) {
            best = x.second;
            ans = 1;
        } else if (x.second == best) {
            ans++;
        }
    }
    return ans;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int g = validator.group() == "" ? 4 : validator.group()[0] - '0';

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = inf.readLine();
        ensuref(3 <= s[i].size() && s[i].size() <= 1000, "length of s[%d]", i + 1);
        for (int j = 0; j < s[i].size(); j++) {
            ensuref(s[i][j] == 'R' || s[i][j] == 'G' || s[i][j] == 'B', "invalid char");
        }
    }
    inf.readEof();

    if (g == 1 || g == 2) {
        ensuref(n == 1, "n must be equal to 1");
    }

    if (g == 1 || g == 3) {
        int cnt = solve(s);
        ensuref(cnt == 1, "there must be unique solution, but there are %d", cnt);
    }

    return 0;
}                          


